Unit ef01r_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, IA01R_p, EF01RG_p;

procedure ef01r(var M :Integer; var N :Integer; var A :Array of Real;
                var F :Array of Real; NG :Integer; var AU :Array of Real;
                var BU :Array of Real; var MU :Array of Integer;
                var P :Array of Real; var Q :Array of Real;
                var D :Array of Real; var R :Array of Real; E :Real;
                ISP :Integer; var U :Array of Real; var FU :Real;
                var KN :Integer; var B :Array of Real; EF01R0 :Proc_EF01R);

implementation

procedure ef01r(var M :Integer; var N :Integer; var A :Array of Real;
                var F :Array of Real; NG :Integer; var AU :Array of Real;
                var BU :Array of Real; var MU :Array of Integer;
                var P :Array of Real; var Q :Array of Real;
                var D :Array of Real; var R :Array of Real; E :Real;
                ISP :Integer; var U :Array of Real; var FU :Real;
                var KN :Integer; var B :Array of Real; EF01R0 :Proc_EF01R);
var
IS_,NX,NGX,K,K1,K2,K3,K4,J,J4,I,NOP,J0,J1,J2,J3 :Integer;
W,FS,BETA,AS_,E2,E3,WF,E4 :Real;
GRG,GRN,V,V1 :Extended;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,_20,
_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32,_33,_34,_35,_36,_37,
_38,_39,_40,_41;
begin
IS_ := 0;
KN := 0;
NX := 1;
NGX := NG+1;
K := M+N;
K1 := K+N;
K2 := K1+N;
K3 := K2+N;
K4 := K3+N;
_1:
case NGX of
 1: goto _11;
 2: goto _2;
 3: goto _7;
 4: goto _7;
end;
_2:
for J:=1 to N do
 begin
  if ( U[J-1]-AU[J-1] ) < 0
   then goto _3
   else if ( U[J-1]-AU[J-1] ) > 0
         then goto _4
         else goto _6;
_3:
  U[J-1] := AU[J-1];
  goto _6;
_4:
  if ( U[J-1]-BU[J-1] ) < 0
   then goto _6
   else if ( U[J-1]-BU[J-1] ) > 0
         then goto _5
         else goto _6;
_5:
  U[J-1] := BU[J-1];
_6:
 end;
goto _11;
_7:
case NX of
 1: goto _8;
 2: goto _10;
end;
_8:
for J:=1 to N do
 begin
  J4 := K4+J;
  B[J4-1] := U[J-1];
_9:
 end;
_10:
IA01R(B[K4+0],U,Q,MU,N);
if ( NGX-4 ) < 0
 then goto _11
 else if ( NGX-4 ) > 0
       then goto _11
       else goto _2;
_11:
NOP := 1;
for J:=1 to N do
 begin
  J4 := K4+J;
_12:
  B[J4-1] := D[J-1]*U[J-1];
 end;
EF01R0(M,N,A,B[K4+0],B[0],NOP);
FU := 0.0;
for I:=1 to M do
 begin
  W := B[I-1]-F[I-1];
  B[I-1] := P[I-1]*W;
_13:
  FU := FU+W*B[I-1];
 end;
case NX of
 1: goto _14;
 2: goto _30;
end;
_14:
NX := 2;
EF01RG(M,N,A,B,R,Q,D,EF01R0);
FS := FU;
for J:=1 to N do
 begin
  J0 := M+J;
_15:
  B[J0-1] := U[J-1];
 end;
if ( IS_ ) < 0
 then goto _18
 else if ( IS_ ) > 0
       then goto _18
       else goto _16;
_16:
for J:=1 to N do
 begin
  J1 := K1+J;
  J3 := K3+J;
_17:
  B[J3-1] := B[J1-1];
 end;
goto _21;
_18:
W := 0.0;
for J:=1 to N do
 begin
  J0 := K+J;
  J1 := K1+J;
  J2 := K2+J;
_19:
  W := W+Q[J-1]*B[J0-1]*(B[J2-1]-B[J1-1]);
 end;
BETA := W/GRN;
for J:=1 to N do
 begin
  J1 := K1+J;
  J3 := K3+J;
_20:
  B[J3-1] := B[J1-1]-BETA*B[J3-1];
 end;
_21:
GRG := 0.0;
GRN := 0.0;
for J:=1 to N do
 begin
  J0 := K+J;
  J1 := K1+J;
  J3 := K3+J;
  V := B[J0-1];
  V1 := Q[J-1]*V;
  GRG := GRG+B[J3-1]*V1;
  GRN := GRN+B[J1-1]*V1;
_22:
 end;
W := Sqrt(GRN);
if ( Abs(W)-E ) < 0
 then goto _40
 else if ( Abs(W)-E ) > 0
       then goto _23
       else goto _40;
_23:
if ( GRG ) < 0
 then goto _16
 else if ( GRG ) > 0
       then goto _24
       else goto _24;
_24:
NOP := 1;
for J:=1 to N do
 begin
  J3 := K3+J;
  J4 := K4+J;
_25:
  B[J4-1] := D[J-1]*B[J3-1];
 end;
EF01R0(M,N,A,B[K4+0],B[0],NOP);
for I:=1 to M do
 begin
_26:
  B[I-1] := P[I-1]*B[I-1];
 end;
NOP := 2;
EF01R0(M,N,A,B[0],B[K+0],NOP);
V := 0.0;
for J:=1 to N do
 begin
  J0 := K+J;
  J3 := K3+J;
  V1 := 2.0*B[J0-1]*D[J-1];
_27:
  V := V+Q[J-1]*B[J3-1]*V1;
 end;
AS_ := GRN/V;
_28:
for J:=1 to N do
 begin
  J0 := M+J;
  J3 := K3+J;
  J4 := K4+J;
  B[J4-1] := B[J0-1]-AS_*B[J3-1];
_29:
  U[J-1] := B[J4-1];
 end;
goto _1;
_30:
E2 := E*E/Abs(V);
E3 := E*E*E2;
WF := FS-FU;
if ( Abs(WF)-E3 ) < 0
 then goto _31
 else if ( Abs(WF)-E3 ) > 0
       then goto _32
       else goto _31;
_31:
KN := 2;
goto _41;
_32:
if ( WF ) < 0
 then goto _37
 else if ( WF ) > 0
       then goto _33
       else goto _33;
_33:
IS_ := IS_+1;
if ( ISP-IS_ ) < 0
 then goto _35
 else if ( ISP-IS_ ) > 0
       then goto _35
       else goto _34;
_34:
KN := 0;
goto _41;
_35:
for J:=1 to N do
 begin
  J1 := K1+J;
  J2 := K2+J;
_36:
  B[J2-1] := B[J1-1];
 end;
goto _14;
_37:
AS_ := 0.5*AS_;
if ( AS_-E2 ) < 0
 then goto _38
 else if ( AS_-E2 ) > 0
       then goto _28
       else goto _38;
_38:
E4 := E*E2;
for J:=1 to N do
 begin
  J0 := M+J;
  if ( Abs(U[J-1]-B[J0-1])-E4 ) < 0
   then goto _39
   else if ( Abs(U[J-1]-B[J0-1])-E4 ) > 0
         then goto _28
         else goto _39;
_39:
 end;
KN := 3;
goto _41;
_40:
KN := 1;
_41:
end;

end.
