Unit ef02r_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, EF01R_p, EF01R1_p;

procedure ef02r(var M :Integer; N :Integer; var A :Array of Real;
                var F :Array of Real; var NG :Integer;
                var V1 :Array of Real; var V2 :Array of Real;
                var MU :Array of Integer; var H :Array of Real;
                var P :Array of Real; var Q :Array of Real;
                var R :Array of Real; var E :Real; var ISP :Integer;
                LU :Integer; var U :Array of Real; var FU :Real;
                var KN :Integer; var B :Array of Real);

implementation

procedure ef02r(var M :Integer; N :Integer; var A :Array of Real;
                var F :Array of Real; var NG :Integer;
                var V1 :Array of Real; var V2 :Array of Real;
                var MU :Array of Integer; var H :Array of Real;
                var P :Array of Real; var Q :Array of Real;
                var R :Array of Real; var E :Real; var ISP :Integer;
                LU :Integer; var U :Array of Real; var FU :Real;
                var KN :Integer; var B :Array of Real);
var
I,J,J1,N1 :Integer;
S,W :Real;
const
SYS059 :Real = 1.7E38;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11;
begin
S := U[0];
N1 := N-1;
for J:=1 to N1 do
 begin
_1:
  U[J-1] := (U[J+0]-U[J-1])/H[J-1];
 end;
U[N-1] := S;
for I:=1 to M do
 begin
  S := 0.0;
  for J:=1 to N1 do
   begin
    J1 := N-J;
    S := S+H[J1-1]/2.0*(A[(I-1)+(J1-1)*M]+A[(I-1)+(J1+0)*M]);
_2:
    B[J1-1] := S;
   end;
  for J:=1 to N1 do
   begin
_3:
    A[(I-1)+(J-1)*M] := B[J-1];
   end;
  if ( LU ) < 0
   then goto _5
   else if ( LU ) > 0
         then goto _5
         else goto _4;
_4:
  A[(I-1)+(N-1)*M] := S;
  goto _6;
_5:
  F[I-1] := F[I-1]-S*U[N-1];
_6:
 end;
V1[N-1] := -SYS059;
V2[N-1] := SYS059;
MU[N-2] := 0;
Q[N-1] := 1.0;
R[N-1] := 0.0;
R[N+0] := 0.0;
H[0] := H[0]/2.0;
S := H[0];
for J:=2 to N1 do
 begin
  W := H[J-1]/2;
  H[J-1] := W+S;
_7:
  S := W;
 end;
H[N-1] := 1.0;
if ( LU ) < 0
 then goto _9
 else if ( LU ) > 0
       then goto _9
       else goto _8;
_8:
N1 := N;
MU[N-1] := 0;
_9:
EF01R(M,N1,A,F,NG,V1,V2,MU,P,Q,H,R,E,ISP,U,FU,KN,
B,EF01R1);
H[0] := 2.0*H[0];
N1 := N-1;
for J:=2 to N1 do
 begin
_10:
  H[J-1] := 2.0*H[J-1]-H[J-2];
 end;
W := U[N-1];
for J:=1 to N1 do
 begin
  S := W;
  W := W+H[J-1]*U[J-1];
_11:
  U[J-1] := S;
 end;
U[N-1] := W;
end;

end.
