Unit ef01rg_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

procedure ef01rg(var M :Integer; var N :Integer; var A :Array of Real;
                 var B :Array of Real; var R :Array of Real;
                 var Q :Array of Real; var D :Array of Real;
                 EF01R0 :Proc_EF01R);

implementation

procedure ef01rg(var M :Integer; var N :Integer; var A :Array of Real;
                 var B :Array of Real; var R :Array of Real;
                 var Q :Array of Real; var D :Array of Real;
                 EF01R0 :Proc_EF01R);
var
K,K1,K4,K5,NOP,J,J0,J1,J4,J5,K2,N1 :Integer;
W :Real;
label
_1,_2,_3,_4,_5,_6;
begin
K := M+N;
K1 := K+N;
K4 := Trunc( K1+3*N );
K5 := K4+N+1;
NOP := 2;
EF01R0(M,N,A,B[0],B[K+0],NOP);
for J:=1 to N do
 begin
  if ( R[J-1] ) < 0
   then goto _3
   else if ( R[J-1] ) > 0
         then goto _3
         else goto _1;
_1:
  J1 := K1+J;
  J0 := K+J;
  B[J0-1] := 2.0*B[J0-1]*D[J-1];
  B[J1-1] := B[J0-1];
_2:
 end;
goto _6;
_3:
B[K4+0] := 0.0;
B[K5+0] := 0.0;
for J:=1 to N do
 begin
  J0 := K+J;
  J4 := K4+J;
  J5 := K5+J;
  B[J0-1] := 2.0*B[J0-1]*D[J-1];
  W := R[J+0]+R[J-1]*(1.0-B[J4-1])+Q[J-1];
  B[J4+0] := R[J+0]/W;
  B[J5+0] := (R[J-1]*B[J5-1]+Q[J-1]*B[J0-1])/W;
_4:
 end;
K2 := K1+N;
J5 := K5+N+1;
B[K2-1] := B[J5-1];
N1 := N-1;
for J:=1 to N1 do
 begin
  J1 := K2-J+1;
  J4 := K4+N-J+1;
  J5 := K5+N-J+1;
_5:
  B[J1-2] := B[J4-1]*B[J1-1]+B[J5-1];
 end;
_6:
end;

end.
